use strict;
use warnings;

use Digest::SHA;
use Devel::Peek;

my $separator = ('-' x 85)."\n";
my ($fh, $utf8, $sha256_sys, $sha256_perl);

print STDERR $separator;

($sha256_sys) = split /\s+/, `sha256sum UTF8`;
printf STDERR "%-20s % 50s\n", "sha256sum command:", $sha256_sys;

print STDERR $separator;

open $fh, 'UTF8';
$utf8 = <$fh>;
close $fh;

print STDERR "perl raw read, before SHA:\n";
Dump $utf8;

$sha256_perl = Digest::SHA->new(256)->add($utf8)->hexdigest;
printf STDERR "%-20s % 50s\n", "perl raw read:", $sha256_perl;

print STDERR "perl raw read, after SHA:\n";
Dump $utf8;

print STDERR $separator;

open $fh, '<:encoding(UTF-8)', 'UTF8';
$utf8 = <$fh>;
close $fh;

print STDERR "perl :utf8 read before SHA:\n";
Dump $utf8;

$sha256_perl = Digest::SHA->new(256)->add($utf8)->hexdigest;
printf STDERR "%-20s % 50s\n", "perl :utf8 read:", $sha256_perl;

print STDERR "perl :utf8 read after SHA:\n";
Dump $utf8;

print STDERR $separator;
